# Copyright (c) 2024 University of Piraeus Research Centre
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# SPDX-License-Identifier: Apache-2.0
# 
# Contributors:
#     Panagiotis Karamolegkos (UPRC) - Author

ACM Instance {'apiVersion': 'codeco.he-codeco.eu/v1alpha1', 'kind': 'CodecoApp', 'metadata': {'creationTimestamp': '2024-05-23T11:33:27Z', 'generation': 1, 'managedFields': [{'apiVersion': 'codeco.he-codeco.eu/v1alpha1', 'fieldsType': 'FieldsV1', 'fieldsV1': {'f:spec': {'.': {}, 'f:appEnergyLimit': {}, 'f:appFailureTolerance': {}, 'f:appName': {}, 'f:codecoapp-msspec': {}, 'f:complianceClass': {}, 'f:qosClass': {}, 'f:securityClass': {}}}, 'manager': 'OpenAPI-Generator', 'operation': 'Update', 'time': '2024-05-23T11:33:27Z'}, {'apiVersion': 'codeco.he-codeco.eu/v1alpha1', 'fieldsType': 'FieldsV1', 'fieldsV1': {'f:status': {'.': {}, 'f:appMetrics': {'.': {}, 'f:avgAppCpu': {}, 'f:avgAppMemory': {}, 'f:avgAppNetworkLoad': {}, 'f:numPods': {}, 'f:serviceMetrics': {}}, 'f:errorMsg': {}, 'f:nodeMetrics': {}, 'f:status': {}}}, 'manager': 'OpenAPI-Generator', 'operation': 'Update', 'subresource': 'status', 'time': '2024-05-24T11:15:26Z'}], 'name': 'acm-sample', 'namespace': 'he-codeco-acm', 'resourceVersion': '157574', 'uid': '40feb79f-5a17-40cf-b907-0ffb9f13dd18'}, 'spec': {'appEnergyLimit': '20', 'appFailureTolerance': '', 'appName': 'acm-swm-app', 'codecoapp-msspec': [{'nwbandwidth': '1.2', 'nwlatency': '3', 'podspec': {'containers': [{'image': 'quay.io/skupper/hello-world-backend:latest', 'name': 'skupper-backend', 'ports': [{'containerPort': 8080, 'name': 'skupper-backend', 'protocol': 'TCP'}], 'resources': {'limits': {'cpu': '2', 'memory': '4Gi'}}}]}, 'serviceChannels': [{'advancedChannelSettings': {'bandwidth': '5', 'frameSize': '100', 'maxDelay': '1', 'sendInterval': '10'}, 'chanelName': 'frontend', 'otherService': {'appName': 'acm-swm-app', 'port': 9090, 'serviceName': 'front-end'}}], 'serviceName': 'backend'}, {'nwbandwidth': '1.2', 'nwlatency': '3', 'podspec': {'containers': [{'image': 'quay.io/dekelly/frontend-app:v0.0.2', 'name': 'front-end', 'ports': [{'containerPort': 8080, 'protocol': 'TCP'}]}]}, 'serviceChannels': [{'advancedChannelSettings': {'bandwidth': '5', 'frameSize': '100', 'maxDelay': '1', 'sendInterval': '10'}, 'chanelName': 'backend', 'otherService': {'appName': 'acm-swm-app', 'port': 8080, 'serviceName': 'backend'}}], 'serviceName': 'front-end'}], 'complianceClass': 'High', 'qosClass': 'Gold', 'securityClass': 'Good'}, 'status': {'appMetrics': {'avgAppCpu': '6', 'avgAppMemory': '2Gi', 'avgAppNetworkLoad': 55, 'numPods': 8, 'serviceMetrics': [{'avgServiceCpu': '77', 'avgServiceEnergy': '3', 'avgServiceFailure': '0', 'avgServiceMemory': '5Gi', 'avgServiceSecurity': '0', 'nodeName': 'c1', 'podId': 'pod-9', 'podName': 'test-pod-1', 'serviceName': 'front-end'}, {'avgServiceCpu': '77', 'avgServiceEnergy': '3', 'avgServiceFailure': '0', 'avgServiceMemory': '5Gi', 'avgServiceSecurity': '0', 'nodeName': 'c1', 'podId': 'pod-10', 'podName': 'test-pod-2', 'serviceName': 'backend'}]}, 'errorMsg': 'No errors', 'nodeMetrics': [{'avgNodeCpu': '77', 'avgNodeEnergy': '3', 'avgNodeFailure': '0', 'avgNodeMemory': '5Gi', 'avgNodeSecurity': '2', 'nodeName': 'c1'}, {'avgNodeCpu': '77', 'avgNodeEnergy': '3', 'avgNodeFailure': '0', 'avgNodeMemory': '4Gi', 'avgNodeSecurity': '2', 'nodeName': 'c2'}], 'status': 'OK'}}
MDM Response Cluster: test-cluster
Namespace: test-namespace
Pod: test-pod
Freshness: unknown
Compliance: unknown
Portability: unknown
MDM Ready {'cluster': 'test-cluster', 'namespace': 'test-namespace', 'pod_name': 'test-pod', 'freshness': 'unknown', 'compliance': 'unknown', 'portability': 'unknown'}
NETMA U Instance {'apiVersion': 'codeco.com/v1', 'kind': 'NETMA-U', 'metadata': {'creationTimestamp': '2024-05-23T11:33:23Z', 'generation': 1, 'managedFields': [{'apiVersion': 'codeco.com/v1', 'fieldsType': 'FieldsV1', 'fieldsV1': {'f:spec': {'.': {}, 'f:links': {}, 'f:networkImplementation': {}, 'f:nodes': {}, 'f:paths': {}, 'f:physicalBase': {}}}, 'manager': 'OpenAPI-Generator', 'operation': 'Update', 'time': '2024-05-23T11:33:23Z'}], 'name': 'netma-sample-underlay', 'namespace': 'he-codeco-netma', 'resourceVersion': '3394', 'uid': '961e7f69-0f59-427d-8272-3ab3ce2cfed4'}, 'spec': {'links': [{'name': 'link-sonem-control-plane-network-node', 'source': 'sonem-control-plane', 'target': 'network-node'}, {'name': 'link-network-node-sonem-control-plane', 'source': 'network-node', 'target': 'sonem-control-plane'}, {'name': 'link-sonem-worker-network-node', 'source': 'sonem-worker', 'target': 'network-node'}, {'name': 'link-network-node-sonem-worker', 'source': 'network-node', 'target': 'sonem-worker'}, {'name': 'link-sonem-worker2-network-node', 'source': 'sonem-worker2', 'target': 'network-node'}, {'name': 'link-network-node-sonem-worker2', 'source': 'network-node', 'target': 'sonem-worker2'}], 'networkImplementation': 'underlay-network', 'nodes': [{'capabilities': {'uNodeBandWidth': '1G', 'uNodeDegree': 1, 'uNodeThroughput': '0G'}, 'name': 'sonem-control-plane', 'type': 'COMPUTE'}, {'capabilities': {'uNodeBandWidth': '2G', 'uNodeDegree': 2, 'uNodeThroughput': '1G'}, 'name': 'sonem-worker', 'type': 'COMPUTE'}, {'capabilities': {'uNodeBandWidth': '3G', 'uNodeDegree': 3, 'uNodeThroughput': '2G'}, 'name': 'sonem-worker2', 'type': 'COMPUTE'}, {'capabilities': {'uNodeDegree': 3, 'uNodeNetFailure': 0}, 'name': 'network-node', 'type': 'NETWORK'}], 'paths': [{'capabilities': {'uBandWidthBits': '1G', 'uLatencyNanos': '1e6', 'uPacketLoss': 0, 'uPathFailure': 0, 'uPathLength': 1}, 'name': 'path-sonem-control-plane-sonem-worker', 'source': 'sonem-control-plane', 'target': 'sonem-worker'}, {'capabilities': {'uBandWidthBits': '1G', 'uLatencyNanos': '1e6', 'uPacketLoss': 0, 'uPathFailure': 0, 'uPathLength': 1}, 'name': 'path-sonem-control-plane-sonem-worker2', 'source': 'sonem-control-plane', 'target': 'sonem-worker2'}, {'capabilities': {'uBandWidthBits': '1G', 'uLatencyNanos': '1e6', 'uPacketLoss': 0, 'uPathFailure': 0, 'uPathLength': 1}, 'name': 'path-sonem-worker-sonem-control-plane', 'source': 'sonem-worker', 'target': 'sonem-control-plane'}, {'capabilities': {'uBandWidthBits': '1G', 'uLatencyNanos': '1e6', 'uPacketLoss': 0, 'uPathFailure': 0, 'uPathLength': 1}, 'name': 'path-sonem-worker-sonem-worker2', 'source': 'sonem-worker', 'target': 'sonem-worker2'}, {'capabilities': {'uBandWidthBits': '1G', 'uLatencyNanos': '1e6', 'uPacketLoss': 0, 'uPathFailure': 0, 'uPathLength': 1}, 'name': 'path-sonem-worker2-sonem-control-plane', 'source': 'sonem-worker2', 'target': 'sonem-control-plane'}, {'capabilities': {'uBandWidthBits': '1G', 'uLatencyNanos': '1e6', 'uPacketLoss': 0, 'uPathFailure': 0, 'uPathLength': 1}, 'name': 'path-sonem-worker2-sonem-worker', 'source': 'sonem-worker2', 'target': 'sonem-worker'}], 'physicalBase': 'physical-network'}}
NETMA O Instance {'apiVersion': 'codeco.com/v1', 'kind': 'NETMA-O', 'metadata': {'creationTimestamp': '2024-05-23T11:33:24Z', 'generation': 1, 'managedFields': [{'apiVersion': 'codeco.com/v1', 'fieldsType': 'FieldsV1', 'fieldsV1': {'f:spec': {'.': {}, 'f:links': {}, 'f:networkImplementation': {}, 'f:nodes': {}, 'f:physicalBase': {}}}, 'manager': 'OpenAPI-Generator', 'operation': 'Update', 'time': '2024-05-23T11:33:24Z'}], 'name': 'netma-sample-overlay', 'namespace': 'he-codeco-netma', 'resourceVersion': '3399', 'uid': '8ded94e3-9464-47aa-a515-0ecf64466efb'}, 'spec': {'links': [{'capabilities': {'oBandWidthBits': '1G', 'oLatencyNanos': '2e6'}, 'name': 'link-sonem-control-plane-sonem-worker', 'source': 'sonem-control-plane', 'target': 'sonem-worker'}, {'capabilities': {'oBandWidthBits': '1G', 'oLatencyNanos': '2e6'}, 'name': 'link-sonem-control-plane-sonem-worker2', 'source': 'sonem-control-plane', 'target': 'sonem-worker2'}, {'capabilities': {'oBandWidthBits': '1G', 'oLatencyNanos': '2e6'}, 'name': 'link-sonem-worker-sonem-control-plane', 'source': 'sonem-worker', 'target': 'sonem-control-plane'}, {'capabilities': {'oBandWidthBits': '1G', 'oLatencyNanos': '2e6'}, 'name': 'link-sonem-worker-sonem-worker2', 'source': 'sonem-worker', 'target': 'sonem-worker2'}, {'capabilities': {'oBandWidthBits': '1G', 'oLatencyNanos': '2e6'}, 'name': 'link-sonem-worker2-sonem-control-plane', 'source': 'sonem-worker2', 'target': 'sonem-control-plane'}, {'capabilities': {'oBandWidthBits': '1G', 'oLatencyNanos': '2e6'}, 'name': 'link-sonem-worker2-sonem-worker', 'source': 'sonem-worker2', 'target': 'sonem-worker'}], 'networkImplementation': 'l2sm-network', 'nodes': [{'capabilities': {'oNodeDegree': 1, 'oNodeThroughput': '0G'}, 'name': 'sonem-control-plane', 'type': 'COMPUTE'}, {'capabilities': {'oNodeDegree': 2, 'oNodeThroughput': '1G'}, 'name': 'sonem-worker', 'type': 'COMPUTE'}, {'capabilities': {'oNodeDegree': 3, 'oNodeThroughput': '2G'}, 'name': 'sonem-worker2', 'type': 'COMPUTE'}], 'physicalBase': 'logical-network'}}